<?php
namespace Modules\Relatorio\Services;

 use Zeedhi\Framework\DTO;


class Gop01600ComparativoOrcamentoService{
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }

    public function getUnidades($row) {
        $params = array(
            "P_CDOPERADOR" => $this->environment->getCdOperador(),
            "P_CDEMPRESA" => $row["CDEMPRESA"],
            "P_CDAREAGERE" => $row["CDAREAGERE"],
            "P_CDSEGMER" => $row["CDSEGMER"],
            "P_CDSUPERVISOR" => $row["CDSUPERVISOR"],
            "P_CDGRUPFILI" => $row["CDGRUPFILI"]
        );
        $sql = "SELECT FO.CDFILIAL
                  FROM FILIOPER FO, FILIAL F, FILGRUPFILI G
                 WHERE FO.CDOPERADOR = :P_CDOPERADOR
                   AND FO.CDFILIAL = F.CDFILIAL
                   AND FO.CDFILIAL = G.CDFILIAL(+)
                   AND ((F.CDEMPRESA = :P_CDEMPRESA) OR ('T' = NVL(:P_CDEMPRESA, 'T')))
                   AND ((F.CDAREAGERE = :P_CDAREAGERE) OR ('T' = NVL(:P_CDAREAGERE, 'T')))
                   AND ((F.CDSEGMER = :P_CDSEGMER) OR ('T' = NVL(:P_CDSEGMER, 'T')))
                   AND ((F.CDSUPERVISOR = :P_CDSUPERVISOR) OR ('T' = NVL(:P_CDSUPERVISOR, 'T')))
                   AND ((G.CDGRUPFILI = :P_CDGRUPFILI) OR ('T' = NVL(:P_CDGRUPFILI, 'T')))
                 GROUP BY FO.CDFILIAL
                 ORDER BY FO.CDFILIAL";
                 
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);
    	
    	$arr = array();
    	$retorno = $query->fetchAll();

    	foreach($retorno as $linha){
    	    array_push($arr, $linha["CDFILIAL"]);
    	}
    	return $arr;
    }
}