create or replace
PROCEDURE ETL_COMERCIALMENSAL
                    (P_DTINI  IN DATE,
                     P_DTFINA IN DATE)
IS
 V_DTFIM           DATE;
 V_DTINI           DATE;
 V_NRSEQFATCOM     VARCHAR2(12);
 V_CDSEQUENCIAL    VARCHAR2(20);
 V_NIVEL           VARCHAR2(20);
 V_DTMES           VARCHAR2(07);
 V_DTANO           VARCHAR2(04);
 V_BIM             VARCHAR2(6);
 V_TRI             VARCHAR2(6);
 V_SEM             VARCHAR2(6);
 V_NMCONTACTADO    VARCHAR2(100);
 V_IDCONTAPROV     VARCHAR2(10);
 V_IDSTATUSCONT    VARCHAR2(12);
 V_TIPOCONTATADO   VARCHAR2(10);
 V_CDPAIS          PAIS.CDPAIS%TYPE;
 V_SGESTADO        ESTADO.SGESTADO%TYPE;
 V_CDMUNICIPIO     MUNICIPIO.CDMUNICIPIO%TYPE;
 
 CON_SIM           VARCHAR2(3)  := 'Sim';
 CON_NAO           VARCHAR2(3)  := 'No';
 CON_NAO_LIDO      VARCHAR2(10) := 'No Lido';
 CON_CONCLUIDO     VARCHAR2(9)  := 'Concludo';
 CON_ANDAMENTO     VARCHAR2(12) := 'Em Andamento';
 CON_PROSPECT      VARCHAR2(08) := 'Prospect';
 CON_CLIENTE       VARCHAR2(07) := 'Cliente';
 CON_FORNECEDOR    VARCHAR2(10) := 'Fornecedor';
 CON_VENDEDOR      VARCHAR2(08) := 'Vendedor';
 
 V_DTFINA          DATE;
 
BEGIN
   
    V_DTINI := TO_DATE('01'||TO_CHAR(P_DTINI,'MMYYYY'), 'DDMMYYYY');
    V_DTMES := TO_CHAR(P_DTINI, 'MM');
    V_DTANO := TO_CHAR(P_DTINI, 'YYYY');

     DELETE FROM ETLCOMERCIALMENSAL
     WHERE ( CDANOBI > V_DTANO ) OR
            ( CDANOBI = V_DTANO 
            AND CDMESBI >= V_DTMES );
     COMMIT;
    
   BEGIN
      SELECT NVL(MAX(LPAD(NRSEQFATCOM,12,0)),0)
      INTO   V_NRSEQFATCOM
      FROM   ETLCOMERCIALMENSAL;
   EXCEPTION
   WHEN OTHERS THEN
      V_NRSEQFATCOM := '0';
   END;
   WHILE (V_DTINI  <=  P_DTFINA) LOOP
   
      V_DTFIM := LAST_DAY(V_DTINI);
      
      FOR C_ETL IN
            (SELECT COUNT(CON.CDFILIAL||CON.NRCONTATO||EVO.NRSEQEVOLCON) AS QTCONTATOS, CON.CDFILIAL,
                   CON.CDMOTICONT, CON.IDSTATUSCONT, CON.CDCLIENTE,
                   CON.CDFORNECED, CON.CDPROSPECT, CON.CDVENDEDOR, CON.IDTPCONTATO,
                   CON.CDSISTEMA, CON.CDOPCONCCONT, CON.IDCONTAPROV, EVO.CDOPEREVOL,
                   EVO.CDMOTIEVOCON, SIS.CDPROCOMERCI, CON.CDMTENCECONT
             FROM
                   CONTATO CON, EVOLCONT EVO, SISTEMA SIS
             WHERE
                   (trunc(EVO.DTHREVOLCONT)  BETWEEN V_DTINI AND V_DTFIM)
               AND (EVO.CDFILIAL (+)    = CON.CDFILIAL)
               AND (EVO.NRCONTATO(+)    = CON.NRCONTATO)
               AND (SIS.CDSISTEMA(+)    = CON.CDSISTEMA)
             GROUP BY
                   CON.CDFILIAL, CON.CDMOTICONT, CON.IDSTATUSCONT, CON.CDCLIENTE,
                   CON.CDFORNECED, CON.CDPROSPECT, CON.CDVENDEDOR, CON.IDTPCONTATO,
                   CON.CDSISTEMA, CON.CDOPCONCCONT, CON.IDCONTAPROV, EVO.CDOPEREVOL,
                   EVO.CDMOTIEVOCON, SIS.CDPROCOMERCI, CON.CDMTENCECONT
             )
      LOOP

             IF C_ETL.CDMOTIEVOCON<>'12' THEN
                V_IDCONTAPROV := CON_NAO_LIDO;
             ELSE
                IF C_ETL.IDCONTAPROV = 'S' THEN
                   V_IDCONTAPROV := CON_SIM;
                ELSIF C_ETL.IDCONTAPROV = 'N' THEN
                   V_IDCONTAPROV := CON_NAO;
                ELSE V_IDCONTAPROV := CON_NAO_LIDO;
                END IF;
             END IF;
             IF C_ETL.IDSTATUSCONT = 'C' THEN
                V_IDSTATUSCONT := CON_CONCLUIDO;
             ELSE
                V_IDSTATUSCONT := CON_ANDAMENTO;
             END IF;

             IF C_ETL.IDTPCONTATO='C' THEN
                V_TIPOCONTATADO  := CON_CLIENTE;
                BEGIN
                   SELECT NMFANTCLIE
                   INTO V_NMCONTACTADO
                   FROM CLIENTE
                   WHERE CDCLIENTE = C_ETL.CDCLIENTE;
                EXCEPTION
                WHEN OTHERS THEN
                   V_NMCONTACTADO := NULL;
                END;
                BEGIN
                   SELECT CDPAIS,SGESTADO,CDMUNICIPIO
                   INTO V_CDPAIS,V_SGESTADO,V_CDMUNICIPIO
                   FROM ENDECLIE
                   WHERE (CDCLIENTE = C_ETL.CDCLIENTE) AND
                   (IDTPENDECLIE = 'P');
                EXCEPTION
                WHEN OTHERS THEN
                   BEGIN
                      V_CDPAIS := NULL;
                      V_SGESTADO := NULL;
                      V_CDMUNICIPIO := NULL;
                   END;
                END;
             ELSIF C_ETL.IDTPCONTATO='P' THEN
                   V_TIPOCONTATADO  := CON_PROSPECT;
                   BEGIN
                      SELECT NMFANTPROS
                      INTO V_NMCONTACTADO
                      FROM PROSPECT
                      WHERE (CDPROSPECT = C_ETL.CDPROSPECT)  ;
                      EXCEPTION
                      WHEN OTHERS THEN
                         V_NMCONTACTADO := NULL;
                   END;
                   BEGIN
                      SELECT CDPAIS,SGESTADO,CDMUNICIPIO
                      INTO V_CDPAIS,V_SGESTADO,V_CDMUNICIPIO
                      FROM ENDEPROSPECT
                      WHERE CDPROSPECT = C_ETL.CDPROSPECT AND
                      (IDTPENDEPROS = 'P');
                      EXCEPTION WHEN OTHERS THEN BEGIN
                         V_CDPAIS := NULL;
                         V_SGESTADO := NULL;
                         V_CDMUNICIPIO := NULL;
                      END;
                   END;
             ELSIF C_ETL.IDTPCONTATO='F' THEN
                   V_TIPOCONTATADO  := CON_FORNECEDOR;
                   BEGIN
                      SELECT NMFANTFORN
                      INTO V_NMCONTACTADO
                      FROM FORNECEDOR
                      WHERE (CDFORNECED = C_ETL.CDFORNECED) ;
                      EXCEPTION
                      WHEN OTHERS THEN
                         V_NMCONTACTADO := NULL;
                   END;
                   BEGIN
                      SELECT CDPAIS,SGESTADO,CDMUNICIPIO
                      INTO V_CDPAIS,V_SGESTADO,V_CDMUNICIPIO
                      FROM ENDEFORN
                      WHERE CDFORNECED = C_ETL.CDFORNECED AND
                      (IDTPENDEFORN = 'P');
                      EXCEPTION WHEN OTHERS THEN BEGIN
                         V_CDPAIS := NULL;
                         V_SGESTADO := NULL;
                         V_CDMUNICIPIO := NULL;
                      END;
                   END;
             ELSIF C_ETL.IDTPCONTATO='V' THEN
                   V_TIPOCONTATADO  := CON_VENDEDOR;
                   BEGIN
                      SELECT NMFANVEN
                      INTO V_NMCONTACTADO
                      FROM VENDEDOR
                      WHERE CDVENDEDOR = C_ETL.CDVENDEDOR;
                      EXCEPTION
                      WHEN OTHERS THEN
                         V_NMCONTACTADO := NULL;
                   END;
                   BEGIN
                      SELECT CDPAIS,SGESTADO,CDMUNICIPIO
                      INTO   V_CDPAIS,V_SGESTADO,V_CDMUNICIPIO
                      FROM   ENDEVENDE
                      WHERE  CDVENDEDOR = C_ETL.CDVENDEDOR
                         AND IDTPENDEVEN = 'P';
                      EXCEPTION WHEN OTHERS THEN BEGIN
                         V_CDPAIS := NULL;
                         V_SGESTADO := NULL;
                         V_CDMUNICIPIO := NULL;
                      END;
                   END;
             END IF;
             V_DTMES  :=  TO_CHAR(V_DTINI,'MM');
             V_DTANO  :=  TO_CHAR(V_DTINI,'YYYY');                            
             V_BIM := TRUNC ((V_DTMES - 1) / 2) + 1;
             V_TRI := TRUNC ((V_DTMES - 1) / 3) + 1;
             V_SEM := TRUNC ((V_DTMES - 1) / 6) + 1;

             V_NRSEQFATCOM := LPAD(V_NRSEQFATCOM + 1, 12 ,'0');
             
             INSERT INTO ETLCOMERCIALMENSAL
                    (
                     NRSEQFATCOM,          QTCONTATOS,           CDFILIAL,                           
                     CDMOTICONT,           IDCONTAPROV,          IDSTATUSCONT,
                     CDSISTEMA,            CDANOBI ,             CDMESBI,
                     BIFATCOM,             TRFATCOM,             SEFATCOM,
                     CDOPEREVOL,           CDMOTIEVOCON,         NMCONTATO,
                     CDPAIS,               SGESTADO,             CDMUNICIPIO,
                     CDPROCOMERCI,         DSTPCONTATO,          CDMTENCECONT
                                           
                    )
             VALUES
                    (
                     V_NRSEQFATCOM,       C_ETL.QTCONTATOS,     C_ETL.CDFILIAL,                       
                     C_ETL.CDMOTICONT,     V_IDCONTAPROV,        V_IDSTATUSCONT,
                     C_ETL.CDSISTEMA,      V_DTANO,              V_DTMES,
                     V_BIM||' Bim',       V_TRI||' Tri',       V_SEM||' Sem',
                     C_ETL.CDOPEREVOL,     C_ETL.CDMOTIEVOCON,   V_NMCONTACTADO,
                     V_CDPAIS,             V_SGESTADO||V_CDPAIS, V_CDMUNICIPIO||V_SGESTADO||V_CDPAIS,                      
                     C_ETL.CDPROCOMERCI,   V_TIPOCONTATADO,      C_ETL.CDMTENCECONT
                     
                    );
      COMMIT;
      END LOOP;
      V_DTINI := ADD_MONTHS(V_DTINI,1);
   END LOOP;
END; 
/
BEGIN
   INSERT INTO TABELADW (CDTABELADW, NMTABELADW, IDDRILLDOWN) VALUES ('ETLCOMERCIALMENSAL','Comercial Mensal','N');

   CRIA_FATOS('ETLCOMERCIALMENSAL', 'QTCONTATOS',     'Qtde. Contatos mensal',  'Comercial Mensal');
   
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDFILIAL',	'Filial',	'FILIAL',	'CDFILIAL',	'NMFILIAL',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDMOTICONT',	'Motivo do Contato',	'MOTICONT',	'CDMOTICONT',	'NMMOTICONT',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'IDCONTAPROV',	'Aprovao do Contato',	'',	'',	'',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDANOBI',	'Ano',	'ETLANOBI',	'CDANOBI',	'NMANOBI',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDMESBI',	'Ms',	'ETLMESBI',	'CDMESBI',	'NMMESBI',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDPAIS',	'Pas',	'PAIS',	'CDPAIS',	'nmpais',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDSISTEMA',	'Sistema',	'SISPLAT',	'CDSISTEMA',	'NMSISTEMA',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'NMCONTATO',	'Nome do Contato',	'',	'',	'',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'IDSTATUSCONT',	'Status do Contato',	'',	'',	'',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'DSTPCONTATO',	'Tipo de Contatado',	'',	'',	'',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDMTENCECONT',	'Motivo Encerramento de Contato',	'MOTIENCECONT',	'CDMTENCECONT',	'DSMTENCECONT',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDOPEREVOL',	'Operador Evoluo',	'OPEREVOL',	'CDOPEREVOL',	'NMOPEREVOL',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDMOTIEVOCON',	'Motivo da Evoluo',	'MOTIEVOLCONT',	'CDMOTIEVOCON',	'NMMOTIEVOCON',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'SGESTADO',	'Estado',	'ESTADMUNICIP',	'SGESTADO',	'NMESTADO',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDMUNICIPIO',	'Municpio',	'ESTADMUNICIP',	'CDMUNICIPIO',	'NMMUNICIPIO',	'');
   CRIA_DIME(	'ETLCOMERCIALMENSAL',	'CDPROCOMERCI',	'Produto Comercial',	'PROCOMERCI',	'CDPROCOMERCI',	'NMPROCOMERCI',	'');
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('ETL_FATORESUF','5.09.000'); END;
/

